# Table of contents

* [Welcome to Codon](README.md)

## General

* [Getting started](intro/intro.md)
* [Frequently asked questions](intro/faq.md)
* [Differences with Python](intro/differences.md)
* [Release notes](intro/releases.md)

## Language

* [Basics](language/basics.md)
* [Collections](language/collections.md)
* [Functions](language/functions.md)
* [Classes](language/classes.md)
* [Generators](language/generators.md)
* [Statics](language/statics.md)
* [Other types and features](language/extra.md)
* [Foreign function interface](language/ffi.md)
* [Inline LLVM IR](language/llvm.md)

## Interoperability

* [Python integration](interop/python.md)
* [Python decorator](interop/decorator.md)
* [C/C++ integration](interop/cpp.md)
* [Jupyter integration](interop/jupyter.md)

## Advanced

* [Parallelism and multithreading](advanced/parallel.md)
* [GPU programming](advanced/gpu.md)
* [Pipelines](advanced/pipelines.md)
* [Intermediate representation](advanced/ir.md)
* [Building from source](advanced/build.md)
